/*
 * Created by SharpDevelop.
 * User: Alvaro
 * Date: 08/12/2006
 * Time: 20:33
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Drawing;
using System.Windows.Forms;

namespace Formulacion
{
	/// <summary>
	/// Description of Form1.
	/// </summary>
	public class FarmakitoForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox lstTopics;
		private System.Windows.Forms.PictureBox pctLogo;
		private System.Windows.Forms.Label lblQuestion;
		private System.Windows.Forms.TextBox txtQuestion;
		private System.Windows.Forms.Button btnQuestion;
		private System.Windows.Forms.Label lblTopics;
		private System.Windows.Forms.Label lblWarnung;
		
		private Farmakito.DataFarmakito DFark;
		private Formulacion.PreferenciasDB DBPrefs;
		
		private string dbhost;
		private string dbport;
		private string dbuser;
		private string dbpasoteword;
		
		
		/// <summary>
		/// Incia el formulario
		/// </summary>
		public FarmakitoForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			
			DBPrefs = new Formulacion.PreferenciasDB();
			DBPrefs.AsignarNmbFichero("PrefDataBase.xml");
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FarmakitoForm));
			this.lblWarnung = new System.Windows.Forms.Label();
			this.lblTopics = new System.Windows.Forms.Label();
			this.btnQuestion = new System.Windows.Forms.Button();
			this.txtQuestion = new System.Windows.Forms.TextBox();
			this.lblQuestion = new System.Windows.Forms.Label();
			this.pctLogo = new System.Windows.Forms.PictureBox();
			this.lstTopics = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// lblWarnung
			// 
			this.lblWarnung.Font = new System.Drawing.Font("Tahoma", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblWarnung.Location = new System.Drawing.Point(24, 8);
			this.lblWarnung.Name = "lblWarnung";
			this.lblWarnung.Size = new System.Drawing.Size(400, 32);
			this.lblWarnung.TabIndex = 6;
			this.lblWarnung.Text = "Version experimental. Utilice infinitivos";
			// 
			// lblTopics
			// 
			this.lblTopics.Location = new System.Drawing.Point(120, 88);
			this.lblTopics.Name = "lblTopics";
			this.lblTopics.Size = new System.Drawing.Size(152, 16);
			this.lblTopics.TabIndex = 4;
			this.lblTopics.Text = "Temas relacionados";
			// 
			// btnQuestion
			// 
			this.btnQuestion.Location = new System.Drawing.Point(360, 48);
			this.btnQuestion.Name = "btnQuestion";
			this.btnQuestion.Size = new System.Drawing.Size(64, 24);
			this.btnQuestion.TabIndex = 5;
			this.btnQuestion.Text = "Preguntar";
			this.btnQuestion.Click += new System.EventHandler(this.BtnQuestionClick);
			// 
			// txtQuestion
			// 
			this.txtQuestion.Font = new System.Drawing.Font("Times New Roman", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtQuestion.Location = new System.Drawing.Point(168, 48);
			this.txtQuestion.Name = "txtQuestion";
			this.txtQuestion.Size = new System.Drawing.Size(184, 26);
			this.txtQuestion.TabIndex = 1;
			this.txtQuestion.Text = "";
			// 
			// lblQuestion
			// 
			this.lblQuestion.Location = new System.Drawing.Point(104, 48);
			this.lblQuestion.Name = "lblQuestion";
			this.lblQuestion.Size = new System.Drawing.Size(56, 16);
			this.lblQuestion.TabIndex = 2;
			this.lblQuestion.Text = "Pregunta:";
			// 
			// pctLogo
			// 
			this.pctLogo.Image = ((System.Drawing.Image)(resources.GetObject("pctLogo.Image")));
			this.pctLogo.Location = new System.Drawing.Point(16, 56);
			this.pctLogo.Name = "pctLogo";
			this.pctLogo.Size = new System.Drawing.Size(73, 137);
			this.pctLogo.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pctLogo.TabIndex = 0;
			this.pctLogo.TabStop = false;
			// 
			// lstTopics
			// 
			this.lstTopics.Location = new System.Drawing.Point(120, 112);
			this.lstTopics.Name = "lstTopics";
			this.lstTopics.Size = new System.Drawing.Size(264, 95);
			this.lstTopics.TabIndex = 3;
			this.lstTopics.DoubleClick += new System.EventHandler(this.LstTopicsDoubleClick);
			// 
			// FarmakitoForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(434, 218);
			this.Controls.Add(this.lblWarnung);
			this.Controls.Add(this.btnQuestion);
			this.Controls.Add(this.lblTopics);
			this.Controls.Add(this.lstTopics);
			this.Controls.Add(this.lblQuestion);
			this.Controls.Add(this.txtQuestion);
			this.Controls.Add(this.pctLogo);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "FarmakitoForm";
			this.Text = "Farmakito";
			this.Load += new System.EventHandler(this.FarmakitoFormLoad);
			this.ResumeLayout(false);
		}
		#endregion
		void FarmakitoFormLoad(object sender, System.EventArgs e)
		{
			this.CargarConfiguracionDatabase();
			DFark = new Farmakito.DataFarmakito();
			DFark.AsignaParametrosConexion(this.dbhost,this.dbport,this.dbuser, this.dbpasoteword,"formulacion");
			
		}
		
		
		/// <summary>
		/// Carga la configuracin de la base de datos en la vars
		/// de la clase
		/// </summary>
		void CargarConfiguracionDatabase(){
			string[] prf;
			if ( this.DBPrefs.LeerFichero() )
			{
				prf = this.DBPrefs.CargarPreferenciasDB();
				
				for( int i = 0; i < prf.Length; ++i)
				{
					switch(i){
						case 0: this.dbhost = prf[0]; break;
						case 1: this.dbport = prf[1]; break;
						case 3: this.dbuser = prf[2]; break;
						case 4: this.dbpasoteword = prf[3]; break;
					
					}
				}
				this.DBPrefs.CerrarEntrada();
			}
		}
		
		
		
		void BtnQuestionClick(object sender, System.EventArgs e)
		{
			string[] htemas;
			Farmakito.Oraciones ort = new Farmakito.Oraciones();
			ort.AsignarOracion( this.txtQuestion.Text );
			ort.DividirPalabras();
			if ( DFark.Conectar() )
			{
				htemas = DFark.GetScoreElements( ort.palabras );
				this.lstTopics.Items.Clear();
				for( int i = 0 ; i< htemas.Length; ++i)
					this.lstTopics.Items.Add( htemas[i] );
				DFark.Desconectar();
			}
			
		}
		
		void LstTopicsDoubleClick(object sender, System.EventArgs e)
		{
			// Mostrar en la ayuda en todo su explendor
			
			if ( this.lstTopics.SelectedIndex < 0) 
				FM_Errores.MostrarAviso("Seleccione un tema de ayuda por favor");
			else{
			FormulacionMagistral.HelpDetail hd = new FormulacionMagistral.HelpDetail(this.lstTopics.SelectedItem.ToString());
			hd.ShowDialog();
			hd.Dispose();
			}
			
		}
		
		
		
	}
}
